Package com.xebialabs.deployit.plugin.api.udm.base

# Class BaseConfigurationItem

java.lang.Object
com.xebialabs.deployit.plugin.api.udm.base.BaseConfigurationItem

All Implemented Interfaces:
  `ConfigurationItem`, `Serializable`, `Comparable<BaseConfigurationItem>`

Direct Known Subclasses:
  `AbstractDictionary`, `Application`, `BaseConfigurationItemWithPolicies`, `BaseContainer`, `BaseDeployable`, `BaseDeployed`, `BaseEmbeddedDeployable`, `BaseEmbeddedDeployed`, `BaseProvisioner`, `Configuration`, `Environment`, `Parameters`, `SimpleLookupValueProvider`, `Template`, `Version`

@Metadata(virtual=true, description="Default implementation of a CI that provides ID, name and type information.") public class BaseConfigurationItem extends Object implements ConfigurationItem, Comparable<BaseConfigurationItem>
Default implementation of a `ConfigurationItem` that provides id, name and type information.

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected String`
  `id`
  `protected Map<String,Object>`
  `syntheticProperties`
  `protected Type`
  `type`

  ### Fields inherited from interface com.xebialabs.deployit.plugin.api.udm.ConfigurationItem

  `SYNTHETIC_PROPERTIES_FIELD, TYPE_FIELD`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BaseConfigurationItem()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `compareTo(BaseConfigurationItem o)`
  `boolean`
  `equals(Object thatObject)`
  `CiAttributes`
  `get$ciAttributes()`
  `String`
  `get$directoryReference()`
  `Map<String,ExternalProperty>`
  `get$externalProperties()`
  `String`
  `get$internalId()`
  `String`
  `get$referenceId()`
  `String`
  `get$securedCi()`
  `String`
  `get$securedDirectoryReference()`
  `String`
  `get$token()`
  `List<ValidationMessage>`
  `get$validationMessages()`
  Gets the validation messages set on the ConfigurationItem.
  `String`
  `getId()`
  `String`
  `getName()`
  `<T> T`
  `getProperty(String key)`
  `protected PropertyDescriptor`
  `getPropertyDescriptor(String name)`
  `Type`
  `getType()`
  `int`
  `hashCode()`
  `boolean`
  `hasProperty(String key)`
  `void`
  `set$ciAttributes(CiAttributes $ciAttributes)`
  Sets attributes of ci modification.
  `void`
  `set$directoryReference(String $directoryReference)`
  `void`
  `set$externalProperties(Map<String,ExternalProperty> externalProperties)`
  `void`
  `set$internalId(String internalId)`
  `void`
  `set$referenceId(String $referenceId)`
  `void`
  `set$securedCi(String securedCi)`
  `void`
  `set$securedDirectoryReference(String $securedDirectoryReference)`
  `void`
  `set$token(String $token)`
  `void`
  `set$validationMessages(List<ValidationMessage> $validationMessages)`
  `void`
  `setId(String id)`
  Sets The id of the CI.
  `<T> void`
  `setProperty(String key, T value)`
  Adds a custom property of a generic type to the CI.
  `void`
  `setType(Type type)`
  Sets the type metadata for this CI.
  `String`
  `toString()`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### id

    protected String id

  - ### type

    protected Type type

  - ### syntheticProperties

    protected Map<String,Object> syntheticProperties

- ## Constructor Details

  - ### BaseConfigurationItem

    public BaseConfigurationItem()

- ## Method Details

  - ### getId

    public String getId()
    Specified by:
      `getId` in interface `ConfigurationItem`
    Returns:
      The id of the CI.

  - ### setId

    public void setId(String id)
    Description copied from interface: `ConfigurationItem`
    Sets The id of the CI.
    Specified by:
      `setId` in interface `ConfigurationItem`

  - ### getName

    public String getName()
    Specified by:
      `getName` in interface `ConfigurationItem`
    Returns:
      The name of the CI.

  - ### getType

    public Type getType()
    Specified by:
      `getType` in interface `ConfigurationItem`
    Returns:
      The type metadata for this CI.

  - ### setType

    public void setType(Type type)
    Sets the type metadata for this CI.

  - ### getProperty

    public <T> T getProperty(String key)
    Specified by:
      `getProperty` in interface `ConfigurationItem`
    Type Parameters:
      `T` - The type of the property.
    Parameters:
      `key` - The name of the property.
    Returns:
      The value of type T of the property.

  - ### hasProperty

    public boolean hasProperty(String key)
    Specified by:
      `hasProperty` in interface `ConfigurationItem`
    Parameters:
      `key` - The name of the property.
    Returns:
      True if the CI has a added property with the given name.

  - ### setProperty

    public <T> void setProperty(String key, T value)
    Description copied from interface: `ConfigurationItem`
    Adds a custom property of a generic type to the CI.
    Specified by:
      `setProperty` in interface `ConfigurationItem`
    Type Parameters:
      `T` - The type of the property.
    Parameters:
      `key` - The name of the property.
      `value` - The value of type T of the property.

  - ### get$ciAttributes

    public CiAttributes get$ciAttributes()
    Returns:
      attributes of ci modification.

  - ### set$ciAttributes

    public void set$ciAttributes(CiAttributes $ciAttributes)
    Sets attributes of ci modification.
    Parameters:
      `$ciAttributes` - attributes of ci modification

  - ### getPropertyDescriptor

    protected PropertyDescriptor getPropertyDescriptor(String name)

  - ### get$token

    public String get$token()
    Returns:
      The JCR optimistic locking token.

  - ### set$token

    public void set$token(String $token)
    Parameters:
      `$token` - The JCR optimistic locking token.

  - ### get$validationMessages

    public List<ValidationMessage> get$validationMessages()
    Description copied from interface: `ConfigurationItem`
    Gets the validation messages set on the ConfigurationItem.
    Specified by:
      `get$validationMessages` in interface `ConfigurationItem`
    Returns:
      a List<ValidationMessage>

  - ### set$validationMessages

    public void set$validationMessages(List<ValidationMessage> $validationMessages)

  - ### get$externalProperties

    public Map<String,ExternalProperty> get$externalProperties()

  - ### set$externalProperties

    public void set$externalProperties(Map<String,ExternalProperty> externalProperties)

  - ### get$internalId

    public String get$internalId()
    Specified by:
      `get$internalId` in interface `ConfigurationItem`
    Returns:
      The internal ID of ConfigurationItem.

  - ### set$internalId

    public void set$internalId(String internalId)

  - ### get$securedCi

    public String get$securedCi()
    Specified by:
      `get$securedCi` in interface `ConfigurationItem`
    Returns:
      The ID of secured CI which determines ConfigurationItem's permissions.

  - ### set$securedCi

    public void set$securedCi(String securedCi)

  - ### get$directoryReference

    public String get$directoryReference()
    Specified by:
      `get$directoryReference` in interface `ConfigurationItem`
    Returns:
      The UUID of ConfigurationItem's directory.

  - ### set$directoryReference

    public void set$directoryReference(String $directoryReference)

  - ### get$securedDirectoryReference

    public String get$securedDirectoryReference()
    Specified by:
      `get$securedDirectoryReference` in interface `ConfigurationItem`
    Returns:
      The UUID of ConfigurationItems secured directory which determines ConfigurationItems permissions.

  - ### set$securedDirectoryReference

    public void set$securedDirectoryReference(String $securedDirectoryReference)

  - ### get$referenceId

    public String get$referenceId()
    Specified by:
      `get$referenceId` in interface `ConfigurationItem`
    Returns:
      The reference UUID of ConfigurationItem.

  - ### set$referenceId

    public void set$referenceId(String $referenceId)

  - ### equals

    public boolean equals(Object thatObject)
    Overrides:
      `equals` in class `Object`

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `Object`

  - ### compareTo

    public int compareTo(BaseConfigurationItem o)
    Specified by:
      `compareTo` in interface `Comparable<BaseConfigurationItem>`

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`